Src/Presentation/3-UI/AdminPanel/Areas/Membership/Controllers/OperatorsController.cs
using TaskoMask.Application.Membership.Operators.Services;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using AutoMapper;
using TaskoMask.Presentation.Framework.Web.Controllers;
using TaskoMask.Application.Share.Dtos.Membership.Operators;
using TaskoMask.Presentation.Framework.Web.Helpers;
using TaskoMask.Application.Share.Dtos.Authorization.Users;
using TaskoMask.Presentation.Framework.Web.Filters;
using TaskoMask.Presentation.Framework.Web.Enums;
using TaskoMask.Presentation.Framework.Web.Extensions;
using TaskoMask.Application.Authorization.Users.Services;

namespace TaskoMask.Presentation.UI.AdminPanle.Areas.Membership.Controllers
{

    [Authorize]
    [Area("Membership")]
    public class OperatorsController : BaseMvcController
    {
        #region Fields

        private readonly IOperatorService _operatorService;
        private readonly IUserService _userService;

        #endregion

        #region Ctor

        public OperatorsController(IOperatorService operatorService, IMapper mapper, IUserService userService) : base(mapper)
        {
            _operatorService = operatorService;
            _userService = userService;
        }

        #endregion

        #region Public Methods





        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Index()
        {
            var rolesListQueryResult = await _operatorService.GetListAsync();
            return View(rolesListQueryResult);
        }






        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<ActionResult> Create()
        {
            return View();
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(OperatorUpsertDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _operatorService.CreateAsync(input);
            var redirectUrl = $"/membership/operators/update/EntityId";
            return AjaxResult(cmdResult, redirectUrl: redirectUrl);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Update(string id)
        {
            var @operator = await _operatorService.GetDetailsAsync(id);
            return View(@operator);
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Update(OperatorUpsertDto input)
        {
            ModelState.Remove(nameof(OperatorUpsertDto.Password));
            ModelState.Remove(nameof(OperatorUpsertDto.ConfirmPassword));

            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _operatorService.UpdateAsync(input);
            return AjaxResult(cmdResult);
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> ResetPassword(UserResetPasswordDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _userService.ResetPasswordAsync(input.Id,input.NewPassword);
            return AjaxResult(cmdResult);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> ChangePassword(UserChangePasswordDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _userService.ChangePasswordAsync(input.Id, input.OldPassword, input.NewPassword);
            return AjaxResult(cmdResult);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [IgnoreAntiforgeryToken]
        public async Task<JavaScriptResult> SetIsActive(string id, bool isActive)
        {
            var cmdResult = await _userService.SetIsActiveAsync(id, isActive);
            return AjaxResult(cmdResult,reloadPage:true);

        }



        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<JavaScriptResult> UpdateRoles(string id, string[]rolesId)
        {
            var cmdResult = await _operatorService.UpdateRolesAsync(id, rolesId);
            return AjaxResult(cmdResult);
        }




        #endregion

        #region Private Methods



        #endregion


    }
}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/Create.cshtml
@model TaskoMask.Application.Share.Dtos.Membership.Operators.OperatorUpsertDto

@{
    ViewBag.Title = "Create new operator";
}

<div class="grid-50 tablet-grid-50 mobile-grid-100">
    <div class="block">
        <div class="block-content">
            @await Html.PartialAsync("_SaveForm", Model)
        </div>
    </div>
</div>

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/Index.cshtml
@model IEnumerable<TaskoMask.Application.Share.Dtos.Membership.Operators.OperatorBasicInfoDto>
@{
    ViewBag.Title = "Operators List";
}

<div class="grid-content">
    <div class="block">
        <div class="block-bar">
            <div class="form"">
                <a href="@Url.Action("Create", "Operators", new { })" class="btn btn-success">New Operatore</a>
            </div>
        </div>
        <div id="ajax-show-list">
            @await Html.PartialAsync("_ItemList", Model)
        </div>
    </div>
</div>


@section scripts{

}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/Update.cshtml
@model TaskoMask.Application.Share.ViewModels.OperatorDetailsViewModel
@using TaskoMask.Application.Share.Dtos.Authorization.Users

@{
    ViewBag.Title = "Update operator";
}

<div class="grid-100 tablet-grid-100 mobile-grid-100">
    <div class="block">
        <div class="block-content no-pad">
            <ul class="tabs">
                <li class="tab"><a href="#tab-1" class="active">Basic Info</a></li>
                <li class="tab"><a href="#tab-2" class="">Change Password</a></li>
                <li class="tab"><a href="#tab-3" class="">Reset Password</a></li>
                <li class="tab"><a href="#tab-4" class="">Account Setting</a></li>
                <li class="tab"><a href="#tab-5" class="">Roles</a></li>
            </ul>
        </div>

        <div id="tab-1">
            <div class="block-content">
                @await Html.PartialAsync("_SaveForm", Model.Operator)
            </div>
        </div>
        <div id="tab-2">
            <div class="block-content">
                @await Html.PartialAsync("_ChangePassword", new UserChangePasswordDto { Id = Model.Operator.Id })
            </div>
        </div>
        <div id="tab-3">
            <div class="block-content">
                @await Html.PartialAsync("_ResetPassword", new UserResetPasswordDto { Id = Model.Operator.Id })
            </div>
        </div>
        <div id="tab-4">
            <div class="block-content">
                @await Html.PartialAsync("_SetUserIsActive", new TaskoMask.Presentation.UI.AdminPanle.Models.SetUserActiveViewModel(id: Model.Operator.Id, isActive: Model.Operator.UserInfo.IsActive))
            </div>
        </div>

        <div id="tab-5"> 
            <div class="block-content  has-table">
                @await Html.PartialAsync("_UpdateRoles", Model)
            </div>
        </div>
    </div>
</div>






@section scripts{

}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/_ChangePassword.cshtml
@model TaskoMask.Application.Share.Dtos.Authorization.Users.UserChangePasswordDto

<form class="form" asp-action="ChangePassword" data-ajax="true" data-ajax-loading="#global-ajax-loading" data-ajax-method="Post">
    <fieldset>
        @Html.AntiForgeryToken()

        @Html.HiddenFor(model => model.Id)

        @Html.LabelFor(model => model.OldPassword)
        @Html.PasswordFor(model => model.OldPassword, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.OldPassword, "", new { @class = "form-message is-error" })


        @Html.LabelFor(model => model.NewPassword)
        @Html.PasswordFor(model => model.NewPassword, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.NewPassword, "", new { @class = "form-message is-error" })

        @Html.LabelFor(model => model.ConfirmNewPassword)
        @Html.PasswordFor(model => model.ConfirmNewPassword, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.ConfirmNewPassword, "", new { @class = "form-message is-error" })


        <hr />
        <button type="submit" class="btn btn-primary">
          Change Password
        </button>

    </fieldset>
</form>

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/_ItemList.cshtml
@model IEnumerable<TaskoMask.Application.Share.Dtos.Membership.Operators.OperatorBasicInfoDto>
@{
}

@if (Model.Count() == 0)
{
    <div id="no-item-alert-area" class="grid-container">
        <div class="alert alert-info">
            <h4>No item to show!</h4>
        </div>
    </div>
}
else
{
    <div class="block-content has-table">
        <div class="table-responsive">
            <table class="table table-striped table-hover">
                <thead>
                    <tr>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().DisplayName)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().UserInfo.UserName)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().RolesId)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().UserInfo.IsActive)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().CreationTime.CreateDateTimeString)</th>
                        <th><label></label></th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var item in Model)
                    {

                        <tr data-table-row-id="@item.Id">
                            <td> @item.DisplayName </td>
                            <td> @item.UserInfo.UserName </td>
                            <td> @item.RolesId.Count() </td>
                            <td> @(item.UserInfo.IsActive?"active":"deactivated") </td>
                            <td> @item.CreationTime.CreateDateTimeString </td>
                            <td>
                                <div class="btn-group-xs">
                                    <a href="@Url.Action( "update", new { id = item.Id }) " class=" btn btn-primary btn-xs btn-xs-circle">
                                        <i class="fa fa-pencil"></i>
                                    </a>
                                </div>
                            </td>
                        </tr>
                    }

                </tbody>
            </table>
        </div>
    </div>
}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/_ResetPassword.cshtml
@model TaskoMask.Application.Share.Dtos.Authorization.Users.UserResetPasswordDto

<form class="form" asp-action="ResetPassword" data-ajax="true" data-ajax-loading="#global-ajax-loading" data-ajax-method="Post">
    <fieldset>
        @Html.AntiForgeryToken()

        @Html.HiddenFor(model => model.Id)



        @Html.LabelFor(model => model.NewPassword)
        @Html.PasswordFor(model => model.NewPassword, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.NewPassword, "", new { @class = "form-message is-error" })

        @Html.LabelFor(model => model.ConfirmNewPassword)
        @Html.PasswordFor(model => model.ConfirmNewPassword, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.ConfirmNewPassword, "", new { @class = "form-message is-error" })


        <hr />
        <button type="submit" class="btn btn-primary">
            Reset Password
        </button>

    </fieldset>
</form>

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/_SaveForm.cshtml
@model TaskoMask.Application.Share.Dtos.Membership.Operators.OperatorUpsertDto
@{
    var actionName = ViewContext.RouteData.Values["action"].ToString();
}
<form class="form" asp-action="@actionName" data-ajax="true" data-ajax-loading="#global-ajax-loading" data-ajax-method="Post">

    <fieldset>
        @Html.AntiForgeryToken()
        @Html.HiddenFor(model => model.Id)



        @Html.LabelFor(model => model.DisplayName)
        @Html.TextBoxFor(model => model.DisplayName, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.DisplayName, "", new { @class = "form-message is-error" })



        @Html.LabelFor(model => model.Email)
        @Html.TextBoxFor(model => model.Email, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.Email, "", new { @class = "form-message is-error" })



        @Html.LabelFor(model => model.UserName)
        @Html.TextBoxFor(model => model.UserName, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.UserName, "", new { @class = "form-message is-error" })


        @if (actionName.ToLower() == "Create")
        {
            @Html.LabelFor(model => model.Password)
            @Html.PasswordFor(model => model.Password, new { @class = "form-input-1" })
            @Html.ValidationMessageFor(model => model.Password, "", new { @class = "form-message is-error" })

            @Html.LabelFor(model => model.ConfirmPassword)
            @Html.PasswordFor(model => model.ConfirmPassword, new { @class = "form-input-1" })
            @Html.ValidationMessageFor(model => model.ConfirmPassword, "", new { @class = "form-message is-error" })
        }


        <hr />

        <button type="submit" class="btn btn-primary">
            Save Changes
        </button>
        <a href="@Url.Action("Index", "Operators", new { })" class="btn btn-default">
            Back
        </a>

    </fieldset>
</form>

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Operators/_UpdateRoles.cshtml
@model TaskoMask.Application.Share.ViewModels.OperatorDetailsViewModel

    <div class="grid-50 tablet-grid-100 mobile-grid-100">
        <div class="table-responsive">
            <form class="form" asp-action="UpdateRoles" data-ajax="true" data-ajax-loading="#global-ajax-loading" data-ajax-method="Post">
                @Html.AntiForgeryToken()

                <input type="hidden" name="id" value="@Model.Operator.Id" />
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th><label> </label></th>
                            <th width="50"><label></label></th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach (var role in Model.Roles)
                        {
                            <tr>
                                <td>@role.Text</td>
                                <td><input type="checkbox" name="RolesId" value="@role.Value" checked=@(role.Selected == true ? "checked" : null ) /></td>
                            </tr>
                        }
                    </tbody>
                </table>

                <button type="submit" class="btn btn-primary">
                    Save Roles
                </button>
                <hr />
            </form>

        </div>
    </div>